Index: trunk/sources/HeuristicLab.RealVector/AverageCrossover.cs
===================================================================
--- trunk/sources/HeuristicLab.RealVector/AverageCrossover.cs	(revision 73)
+++ 	(revision )
@@ -1,31 +1,0 @@
-﻿using System;
-using System.Collections.Generic;
-using System.Text;
-using HeuristicLab.Core;
-using HeuristicLab.Data;
-
-namespace HeuristicLab.RealVector {
-  class AverageCrossover : RealVectorCrossoverBase {
-    public override string Description {
-      get { return "Average (Continuous) crossover for real vectors."; }
-    }
-
-    public static double[] Apply(IRandom random, double[] parent1, double[] parent2) {
-      int length = parent1.Length;
-      double[] result = new double[length];
-
-      for (int i = 0; i < length; i++) {
-        if (random.NextDouble() < 0.5) {
-          result[i] = (parent1[i] + parent2[i]) / 2;
-        } else {
-          result[i] = parent1[i];
-        }
-      }
-      return result;
-    }
-
-    protected override double[] Cross(IScope scope, IRandom random, double[] parent1, double[] parent2) {
-      return Apply(random, parent1, parent2);
-    }
-  }
-}
Index: trunk/sources/HeuristicLab.RealVector/CompleteAverageCrossover.cs
===================================================================
--- trunk/sources/HeuristicLab.RealVector/CompleteAverageCrossover.cs	(revision 73)
+++ 	(revision )
@@ -1,26 +1,0 @@
-﻿using System;
-using System.Collections.Generic;
-using System.Text;
-using HeuristicLab.Core;
-using HeuristicLab.Data;
-
-namespace HeuristicLab.RealVector {
-  class CompleteAverageCrossover : RealVectorCrossoverBase {
-    public override string Description {
-      get { return "Complete average (complete continuous) crossover for real vectors."; }
-    }
-
-    public static double[] Apply(IRandom random, double[] parent1, double[] parent2) {
-      int length = parent1.Length;
-      double[] result = new double[length];
-
-      for (int i = 0; i < length; i++)
-        result[i] = (parent1[i] + parent2[i]) / 2;
-      return result;
-    }
-
-    protected override double[] Cross(IScope scope, IRandom random, double[] parent1, double[] parent2) {
-      return Apply(random, parent1, parent2);
-    }
-  }
-}
Index: trunk/sources/HeuristicLab.RealVector/CompleteContinuousCrossover.cs
===================================================================
--- trunk/sources/HeuristicLab.RealVector/CompleteContinuousCrossover.cs	(revision 74)
+++ trunk/sources/HeuristicLab.RealVector/CompleteContinuousCrossover.cs	(revision 74)
@@ -0,0 +1,26 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Text;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+
+namespace HeuristicLab.RealVector {
+  class CompleteContinuousCrossover : RealVectorCrossoverBase {
+    public override string Description {
+      get { return "Complete continuous crossover for real vectors."; }
+    }
+
+    public static double[] Apply(IRandom random, double[] parent1, double[] parent2) {
+      int length = parent1.Length;
+      double[] result = new double[length];
+
+      for (int i = 0; i < length; i++)
+        result[i] = (parent1[i] + parent2[i]) / 2;
+      return result;
+    }
+
+    protected override double[] Cross(IScope scope, IRandom random, double[] parent1, double[] parent2) {
+      return Apply(random, parent1, parent2);
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.RealVector/ContinuousCrossover.cs
===================================================================
--- trunk/sources/HeuristicLab.RealVector/ContinuousCrossover.cs	(revision 74)
+++ trunk/sources/HeuristicLab.RealVector/ContinuousCrossover.cs	(revision 74)
@@ -0,0 +1,31 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Text;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+
+namespace HeuristicLab.RealVector {
+  class ContinuousCrossover : RealVectorCrossoverBase {
+    public override string Description {
+      get { return "Continuous crossover for real vectors."; }
+    }
+
+    public static double[] Apply(IRandom random, double[] parent1, double[] parent2) {
+      int length = parent1.Length;
+      double[] result = new double[length];
+
+      for (int i = 0; i < length; i++) {
+        if (random.NextDouble() < 0.5) {
+          result[i] = (parent1[i] + parent2[i]) / 2;
+        } else {
+          result[i] = parent1[i];
+        }
+      }
+      return result;
+    }
+
+    protected override double[] Cross(IScope scope, IRandom random, double[] parent1, double[] parent2) {
+      return Apply(random, parent1, parent2);
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.RealVector/HeuristicLab.RealVector.csproj
===================================================================
--- trunk/sources/HeuristicLab.RealVector/HeuristicLab.RealVector.csproj	(revision 73)
+++ trunk/sources/HeuristicLab.RealVector/HeuristicLab.RealVector.csproj	(revision 74)
@@ -40,10 +40,10 @@
   </ItemGroup>
   <ItemGroup>
-    <Compile Include="AverageCrossover.cs" />
-    <Compile Include="CompleteAverageCrossover.cs" />
+    <Compile Include="ContinuousCrossover.cs" />
+    <Compile Include="CompleteContinuousCrossover.cs" />
     <Compile Include="DiscreteCrossover.cs" />
     <Compile Include="HeuristicCrossover.cs" />
     <Compile Include="RandomConvexCrossover.cs" />
-    <Compile Include="RandomLocalCrossover.cs" />
+    <Compile Include="LocalCrossover.cs" />
     <Compile Include="UniformAllPositionsManipulator.cs" />
     <Compile Include="UniformRandomRealVectorGenerator.cs" />
Index: trunk/sources/HeuristicLab.RealVector/LocalCrossover.cs
===================================================================
--- trunk/sources/HeuristicLab.RealVector/LocalCrossover.cs	(revision 74)
+++ trunk/sources/HeuristicLab.RealVector/LocalCrossover.cs	(revision 74)
@@ -0,0 +1,29 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Text;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+
+namespace HeuristicLab.RealVector {
+  class LocalCrossover : RealVectorCrossoverBase {
+    public override string Description {
+      get { return "Local crossover for real vectors."; }
+    }
+
+    public static double[] Apply(IRandom random, double[] parent1, double[] parent2) {
+      double factor;
+      int length = parent1.Length;
+      double[] result = new double[length];
+
+      for (int i = 0; i < length; i++) {
+        factor = random.NextDouble();
+        result[i] = (factor * parent1[i]) + ((1 - factor) * parent2[i]);
+      }
+      return result;
+    }
+
+    protected override double[] Cross(IScope scope, IRandom random, double[] parent1, double[] parent2) {
+      return Apply(random, parent1, parent2);
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.RealVector/RandomLocalCrossover.cs
===================================================================
--- trunk/sources/HeuristicLab.RealVector/RandomLocalCrossover.cs	(revision 73)
+++ 	(revision )
@@ -1,29 +1,0 @@
-﻿using System;
-using System.Collections.Generic;
-using System.Text;
-using HeuristicLab.Core;
-using HeuristicLab.Data;
-
-namespace HeuristicLab.RealVector {
-  class RandomLocalCrossover : RealVectorCrossoverBase {
-    public override string Description {
-      get { return "Random local crossover for real vectors."; }
-    }
-
-    public static double[] Apply(IRandom random, double[] parent1, double[] parent2) {
-      double factor;
-      int length = parent1.Length;
-      double[] result = new double[length];
-
-      for (int i = 0; i < length; i++) {
-        factor = random.NextDouble();
-        result[i] = (factor * parent1[i]) + ((1 - factor) * parent2[i]);
-      }
-      return result;
-    }
-
-    protected override double[] Cross(IScope scope, IRandom random, double[] parent1, double[] parent2) {
-      return Apply(random, parent1, parent2);
-    }
-  }
-}