Index: trunk/sources/HeuristicLab.ES/ESEditor.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.ES/ESEditor.Designer.cs	(revision 86)
+++ trunk/sources/HeuristicLab.ES/ESEditor.Designer.cs	(revision 87)
@@ -52,6 +52,4 @@
       this.targetSuccessRateTextBox = new System.Windows.Forms.TextBox();
       this.targetSuccessRateLabel = new System.Windows.Forms.Label();
-      this.plusNotationButton = new System.Windows.Forms.Button();
-      this.plusNotationLabel = new System.Windows.Forms.Label();
       this.setEvaluationButton = new System.Windows.Forms.Button();
       this.setMutationButton = new System.Windows.Forms.Button();
@@ -93,7 +91,11 @@
       this.setRecombinationButton = new System.Windows.Forms.Button();
       this.viewRecombinationButton = new System.Windows.Forms.Button();
+      this.parentSelectionGroupBox = new System.Windows.Forms.GroupBox();
+      this.plusRadioButton = new System.Windows.Forms.RadioButton();
+      this.commaRadioButton = new System.Windows.Forms.RadioButton();
       this.tabControl.SuspendLayout();
       this.parametersTabPage.SuspendLayout();
       this.scopesTabPage.SuspendLayout();
+      this.parentSelectionGroupBox.SuspendLayout();
       this.SuspendLayout();
       // 
@@ -124,4 +126,5 @@
       // parametersTabPage
       // 
+      this.parametersTabPage.Controls.Add(this.parentSelectionGroupBox);
       this.parametersTabPage.Controls.Add(this.setRecombinationButton);
       this.parametersTabPage.Controls.Add(this.viewRecombinationButton);
@@ -133,6 +136,4 @@
       this.parametersTabPage.Controls.Add(this.targetSuccessRateTextBox);
       this.parametersTabPage.Controls.Add(this.targetSuccessRateLabel);
-      this.parametersTabPage.Controls.Add(this.plusNotationButton);
-      this.parametersTabPage.Controls.Add(this.plusNotationLabel);
       this.parametersTabPage.Controls.Add(this.setEvaluationButton);
       this.parametersTabPage.Controls.Add(this.setMutationButton);
@@ -203,26 +204,4 @@
       this.targetSuccessRateLabel.Text = "Target Success Rate:";
       // 
-      // plusNotationButton
-      // 
-      this.plusNotationButton.Anchor = System.Windows.Forms.AnchorStyles.None;
-      this.plusNotationButton.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
-      this.plusNotationButton.Location = new System.Drawing.Point(218, 239);
-      this.plusNotationButton.Name = "plusNotationButton";
-      this.plusNotationButton.Size = new System.Drawing.Size(78, 24);
-      this.plusNotationButton.TabIndex = 18;
-      this.plusNotationButton.Text = "Plus";
-      this.plusNotationButton.UseVisualStyleBackColor = true;
-      this.plusNotationButton.Click += new System.EventHandler(this.plusNotationButton_Click);
-      // 
-      // plusNotationLabel
-      // 
-      this.plusNotationLabel.Anchor = System.Windows.Forms.AnchorStyles.None;
-      this.plusNotationLabel.AutoSize = true;
-      this.plusNotationLabel.Location = new System.Drawing.Point(65, 245);
-      this.plusNotationLabel.Name = "plusNotationLabel";
-      this.plusNotationLabel.Size = new System.Drawing.Size(113, 13);
-      this.plusNotationLabel.TabIndex = 17;
-      this.plusNotationLabel.Text = "Plus/Comma Notation:";
-      // 
       // setEvaluationButton
       // 
@@ -612,4 +591,40 @@
       this.viewRecombinationButton.UseVisualStyleBackColor = true;
       this.viewRecombinationButton.Click += new System.EventHandler(this.viewRecombinationButton_Click);
+      // 
+      // parentSelectionGroupBox
+      // 
+      this.parentSelectionGroupBox.Anchor = System.Windows.Forms.AnchorStyles.None;
+      this.parentSelectionGroupBox.Controls.Add(this.commaRadioButton);
+      this.parentSelectionGroupBox.Controls.Add(this.plusRadioButton);
+      this.parentSelectionGroupBox.Location = new System.Drawing.Point(218, 239);
+      this.parentSelectionGroupBox.Name = "parentSelectionGroupBox";
+      this.parentSelectionGroupBox.Size = new System.Drawing.Size(186, 38);
+      this.parentSelectionGroupBox.TabIndex = 39;
+      this.parentSelectionGroupBox.TabStop = false;
+      this.parentSelectionGroupBox.Text = "Parent Selection";
+      // 
+      // plusRadioButton
+      // 
+      this.plusRadioButton.AutoSize = true;
+      this.plusRadioButton.Checked = true;
+      this.plusRadioButton.Location = new System.Drawing.Point(6, 15);
+      this.plusRadioButton.Name = "plusRadioButton";
+      this.plusRadioButton.Size = new System.Drawing.Size(45, 17);
+      this.plusRadioButton.TabIndex = 0;
+      this.plusRadioButton.TabStop = true;
+      this.plusRadioButton.Text = "Plus";
+      this.plusRadioButton.UseVisualStyleBackColor = true;
+      this.plusRadioButton.CheckedChanged += new System.EventHandler(this.plusRadioButton_CheckedChanged);
+      // 
+      // commaRadioButton
+      // 
+      this.commaRadioButton.AutoSize = true;
+      this.commaRadioButton.Location = new System.Drawing.Point(57, 15);
+      this.commaRadioButton.Name = "commaRadioButton";
+      this.commaRadioButton.Size = new System.Drawing.Size(60, 17);
+      this.commaRadioButton.TabIndex = 1;
+      this.commaRadioButton.Text = "Comma";
+      this.commaRadioButton.UseVisualStyleBackColor = true;
+      this.commaRadioButton.CheckedChanged += new System.EventHandler(this.commaRadioButton_CheckedChanged);
       // 
       // ESEditor
@@ -628,4 +643,6 @@
       this.parametersTabPage.PerformLayout();
       this.scopesTabPage.ResumeLayout(false);
+      this.parentSelectionGroupBox.ResumeLayout(false);
+      this.parentSelectionGroupBox.PerformLayout();
       this.ResumeLayout(false);
 
@@ -670,6 +687,4 @@
     private System.Windows.Forms.Button viewSolutionGenerationButton;
     private System.Windows.Forms.Button viewProblemInitializationButton;
-    private System.Windows.Forms.Button plusNotationButton;
-    private System.Windows.Forms.Label plusNotationLabel;
     private System.Windows.Forms.TextBox targetSuccessRateTextBox;
     private System.Windows.Forms.Label targetSuccessRateLabel;
@@ -681,4 +696,7 @@
     private System.Windows.Forms.TextBox rhoTextBox;
     private System.Windows.Forms.Label rhoLabel;
+    private System.Windows.Forms.GroupBox parentSelectionGroupBox;
+    private System.Windows.Forms.RadioButton commaRadioButton;
+    private System.Windows.Forms.RadioButton plusRadioButton;
   }
 }
Index: trunk/sources/HeuristicLab.ES/ESEditor.cs
===================================================================
--- trunk/sources/HeuristicLab.ES/ESEditor.cs	(revision 86)
+++ trunk/sources/HeuristicLab.ES/ESEditor.cs	(revision 87)
@@ -97,12 +97,4 @@
 
     #region Button Events
-    private void plusNotationButton_Click(object sender, EventArgs e) {
-      if (plusNotationButton.Text.Equals("Plus")) {
-        plusNotationButton.Text = "Comma";
-      } else {
-        plusNotationButton.Text = "Plus";
-      }
-      ES.PlusNotation = !ES.PlusNotation;
-    }
     private void viewProblemInitializationButton_Click(object sender, EventArgs e) {
       IView view = ES.ProblemInjector.CreateView();
@@ -211,4 +203,14 @@
     }
     #endregion
+
+    #region RadioButton Events
+    private void plusRadioButton_CheckedChanged(object sender, EventArgs e) {
+      if (plusRadioButton.Checked) ES.PlusNotation = true;
+    }
+
+    private void commaRadioButton_CheckedChanged(object sender, EventArgs e) {
+      if (commaRadioButton.Checked) ES.PlusNotation = false;
+    }
+    #endregion
   }
 }