Index: trunk/sources/HeuristicLab.Operators/CombinedOperator.cs
===================================================================
--- trunk/sources/HeuristicLab.Operators/CombinedOperator.cs	(revision 88)
+++ trunk/sources/HeuristicLab.Operators/CombinedOperator.cs	(revision 89)
@@ -28,5 +28,5 @@
 
 namespace HeuristicLab.Operators {
-  public class CombinedOperator : OperatorBase {
+  public class CombinedOperator : DelegatingOperator {
     private string myDescription;
     public override string Description {
@@ -62,35 +62,4 @@
       clone.myOperatorGraph = (IOperatorGraph)Auxiliary.Clone(OperatorGraph, clonedObjects);
       return clone;
-    }
-
-    public override IOperation Execute(IScope scope) {
-      myCanceled = false;
-
-      if (scope.GetVariable(Guid.ToString()) == null) { // contained operator not yet executed
-        // add marker
-        scope.AddVariable(new Variable(Guid.ToString(), new NullData()));
-
-        // add aliases
-        foreach (IVariableInfo variableInfo in VariableInfos)
-          scope.AddAlias(variableInfo.FormalName, variableInfo.ActualName);
-
-        CompositeOperation next = new CompositeOperation();
-        next.AddOperation(Apply(scope));
-        // execute combined operator again after contained operators have been executed
-        next.AddOperation(new AtomicOperation(this, scope));
-
-        OnExecuted();
-        return next;
-      } else {  // contained operator already executed
-        // remove marker
-        scope.RemoveVariable(Guid.ToString());
-
-        // remove aliases
-        foreach (IVariableInfo variableInfo in VariableInfos)
-          scope.RemoveAlias(variableInfo.FormalName);
-
-        OnExecuted();
-        return null;
-      }
     }
 
Index: trunk/sources/HeuristicLab.Operators/DelegatingOperator.cs
===================================================================
--- trunk/sources/HeuristicLab.Operators/DelegatingOperator.cs	(revision 89)
+++ trunk/sources/HeuristicLab.Operators/DelegatingOperator.cs	(revision 89)
@@ -0,0 +1,40 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Text;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+
+namespace HeuristicLab.Operators {
+  public abstract class DelegatingOperator : OperatorBase {
+    public override IOperation Execute(IScope scope) {
+      myCanceled = false;
+
+      if(scope.GetVariable(Guid.ToString()) == null) { // contained operator not yet executed
+        // add marker
+        scope.AddVariable(new Variable(Guid.ToString(), new NullData()));
+
+        // add aliases
+        foreach(IVariableInfo variableInfo in VariableInfos)
+          scope.AddAlias(variableInfo.FormalName, variableInfo.ActualName);
+
+        CompositeOperation next = new CompositeOperation();
+        next.AddOperation(Apply(scope));
+        // execute combined operator again after contained operators have been executed
+        next.AddOperation(new AtomicOperation(this, scope));
+
+        OnExecuted();
+        return next;
+      } else {  // contained operator already executed
+        // remove marker
+        scope.RemoveVariable(Guid.ToString());
+
+        // remove aliases
+        foreach(IVariableInfo variableInfo in VariableInfos)
+          scope.RemoveAlias(variableInfo.FormalName);
+
+        OnExecuted();
+        return null;
+      }
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.Operators/HeuristicLab.Operators.csproj
===================================================================
--- trunk/sources/HeuristicLab.Operators/HeuristicLab.Operators.csproj	(revision 88)
+++ trunk/sources/HeuristicLab.Operators/HeuristicLab.Operators.csproj	(revision 89)
@@ -64,4 +64,5 @@
       <SubType>Code</SubType>
     </Compile>
+    <Compile Include="DelegatingOperator.cs" />
     <Compile Include="StochasticMultiBranch.cs" />
     <Compile Include="SubScopesMixer.cs" />
Index: trunk/sources/HeuristicLab.StructureIdentification/DelegatingOperator.cs
===================================================================
--- trunk/sources/HeuristicLab.StructureIdentification/DelegatingOperator.cs	(revision 88)
+++ 	(revision )
@@ -1,42 +1,0 @@
-﻿using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
-using HeuristicLab.Core;
-using HeuristicLab.Data;
-
-namespace HeuristicLab.StructureIdentification {
-  public abstract class DelegatingOperator : OperatorBase {
-    public override IOperation Execute(IScope scope) {
-      myCanceled = false;
-
-      // copied from CombinedOperator (gkronber 22.3.08)
-      if(scope.GetVariable(Guid.ToString()) == null) { // contained operator not yet executed
-        // add marker
-        scope.AddVariable(new Variable(Guid.ToString(), new NullData()));
-
-        // add aliases
-        foreach(IVariableInfo variableInfo in VariableInfos)
-          scope.AddAlias(variableInfo.FormalName, variableInfo.ActualName);
-
-        CompositeOperation next = new CompositeOperation();
-        next.AddOperation(Apply(scope));
-        // execute combined operator again after contained operators have been executed
-        next.AddOperation(new AtomicOperation(this, scope));
-
-        OnExecuted();
-        return next;
-      } else {  // contained operator already executed
-        // remove marker
-        scope.RemoveVariable(Guid.ToString());
-
-        // remove aliases
-        foreach(IVariableInfo variableInfo in VariableInfos)
-          scope.RemoveAlias(variableInfo.FormalName);
-
-        OnExecuted();
-        return null;
-      }
-    }
-  }
-}
Index: trunk/sources/HeuristicLab.StructureIdentification/HeuristicLab.StructureIdentification.csproj
===================================================================
--- trunk/sources/HeuristicLab.StructureIdentification/HeuristicLab.StructureIdentification.csproj	(revision 88)
+++ trunk/sources/HeuristicLab.StructureIdentification/HeuristicLab.StructureIdentification.csproj	(revision 89)
@@ -48,5 +48,4 @@
   </ItemGroup>
   <ItemGroup>
-    <Compile Include="DelegatingOperator.cs" />
     <Compile Include="Evaluation\CoefficientOfDeterminationEvaluator.cs" />
     <Compile Include="Evaluation\FunctionEvaluator.cs">