Index: /trunk/sources/HeuristicLab.ES/HeuristicLab.ES.csproj
===================================================================
--- /trunk/sources/HeuristicLab.ES/HeuristicLab.ES.csproj	(revision 98)
+++ /trunk/sources/HeuristicLab.ES/HeuristicLab.ES.csproj	(revision 99)
@@ -60,4 +60,5 @@
     </Compile>
     <Compile Include="Properties\AssemblyInfo.cs" />
+    <Compile Include="SelfAdaptiveMutationStrengthAdjuster.cs" />
     <Compile Include="VariableStrengthRepeatingManipulator.cs" />
   </ItemGroup>
Index: /trunk/sources/HeuristicLab.ES/SelfAdaptiveMutationStrengthAdjuster.cs
===================================================================
--- /trunk/sources/HeuristicLab.ES/SelfAdaptiveMutationStrengthAdjuster.cs	(revision 99)
+++ /trunk/sources/HeuristicLab.ES/SelfAdaptiveMutationStrengthAdjuster.cs	(revision 99)
@@ -0,0 +1,57 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Random;
+
+namespace HeuristicLab.ES {
+  public class SelfAdaptiveMutationStrengthAdjuster : OperatorBase {
+    public override string Description {
+      get { return @"Mutates the endogenous strategy parameters"; }
+    }
+
+    public SelfAdaptiveMutationStrengthAdjuster()
+      : base() {
+      AddVariableInfo(new VariableInfo("Random", "Pseudo random number generator", typeof(IRandom), VariableKind.In));
+      AddVariableInfo(new VariableInfo("StrategyVector", "Vector containing the endogenous strategy parameters", typeof(DoubleArrayData), VariableKind.In));
+      AddVariableInfo(new VariableInfo("GeneralLearningRate", "The general learning rate will scale all mutations. It's influence is calculated as: e^(GeneralLearningRate*N(0,1))", typeof(DoubleData), VariableKind.In));
+      AddVariableInfo(new VariableInfo("LearningRate", "Learning parameter defines the strength of the adaption of each component in the object parameter vector", typeof(DoubleData), VariableKind.In));
+    }
+
+    public override IOperation Apply(IScope scope) {
+      IRandom random = GetVariableValue<IRandom>("Random", scope, true);
+      double[] strategyParams = GetVariableValue<DoubleArrayData>("StrategyVector", scope, false).Data;
+      double tau = GetVariableValue<DoubleData>("LearningRate", scope, true).Data;
+      double tau0 = GetVariableValue<DoubleData>("GeneralLearningRate", scope, true).Data;
+
+      NormalDistributedRandom N = new NormalDistributedRandom(random, 0.0, 1.0);
+      double generalMultiplier = Math.Exp(tau0 * N.NextDouble());
+      for (int i = 0; i < strategyParams.Length; i++) {
+        strategyParams[i] *= generalMultiplier * Math.Exp(tau * N.NextDouble());
+      }
+      return base.Apply(scope);
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.RealVector/HeuristicLab.RealVector.csproj
===================================================================
--- /trunk/sources/HeuristicLab.RealVector/HeuristicLab.RealVector.csproj	(revision 98)
+++ /trunk/sources/HeuristicLab.RealVector/HeuristicLab.RealVector.csproj	(revision 99)
@@ -49,4 +49,6 @@
     <Compile Include="LocalCrossover.cs" />
     <Compile Include="DiscreteRecombination.cs" />
+    <Compile Include="SelfAdaptiveDiscreteRecombination.cs" />
+    <Compile Include="SelfAdaptiveNormalAllPositionsManipulator.cs" />
     <Compile Include="UniformAllPositionsManipulator.cs" />
     <Compile Include="UniformRandomRealVectorGenerator.cs" />
Index: /trunk/sources/HeuristicLab.RealVector/SelfAdaptiveDiscreteRecombination.cs
===================================================================
--- /trunk/sources/HeuristicLab.RealVector/SelfAdaptiveDiscreteRecombination.cs	(revision 99)
+++ /trunk/sources/HeuristicLab.RealVector/SelfAdaptiveDiscreteRecombination.cs	(revision 99)
@@ -0,0 +1,80 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+
+namespace HeuristicLab.RealVector {
+  public class SelfAdaptiveDiscreteRecombination : DiscreteRecombination {
+    public override string Description {
+      get {
+        return @"Self adaptive Discrete/dominant recombination creates a new offspring by combining the alleles in the parents such that each allele is randomly selected from one parent. It will also use the same strategy to combine the endogenous strategy parameter vector.";
+      }
+    }
+
+    public SelfAdaptiveDiscreteRecombination()
+      : base() {
+      AddVariableInfo(new VariableInfo("StrategyVector", "Vector containing the endogenous strategy parameters", typeof(DoubleArrayData), VariableKind.In));
+    }
+
+    public override IOperation Apply(IScope scope) {
+      int rho = GetVariableValue<IntData>("Rho", scope, true).Data;
+      // with just 1 parent no recombination is necessary/possible
+      if (rho == 1) return null;
+      IRandom random = GetVariableValue<IRandom>("Random", scope, true);
+
+      if (scope.SubScopes.Count % rho != 0)
+        throw new InvalidOperationException("Number of parents is not a multiple of rho");
+      int lambda = scope.SubScopes.Count / rho;
+      IList<double[]> parents = new List<double[]>(rho);
+      IList<double[]> parentsStrategy = new List<double[]>(rho);
+
+      for (int i = 0; i < lambda; i++) {
+        IScope childScope = new Scope(i.ToString());
+        double[] childGene = (double[])scope.SubScopes[0].GetVariableValue<DoubleArrayData>("RealVector", false).Data.Clone();
+        double[] strategyParams = (double[])scope.SubScopes[0].GetVariableValue<DoubleArrayData>("StrategyVector", false).Data.Clone();
+        parents.Clear();
+        for (int j = 0; j < rho; j++) {
+          IScope parent = scope.SubScopes[0];
+          parents.Add(parent.GetVariableValue<DoubleArrayData>("RealVector", false).Data);
+          parentsStrategy.Add(parent.GetVariableValue<DoubleArrayData>("StrategyVector", false).Data);
+          scope.RemoveSubScope(parent);
+        }
+        // actual discrete recombination
+        if (childGene.Length != strategyParams.Length)
+          throw new InvalidOperationException("ERROR: strategy vector must be as long as there are dimensions");
+
+        for (int x = 0; x < childGene.Length; x++) {
+          int nextParent = random.Next(rho);
+          childGene[x] = parents[nextParent][x];
+          strategyParams[x] = parentsStrategy[nextParent][x];
+        }
+        childScope.AddVariable(new Variable(scope.SubScopes[0].TranslateName("RealVector"), new DoubleArrayData(childGene)));
+        childScope.AddVariable(new Variable(scope.SubScopes[0].TranslateName("StrategyVector"), new DoubleArrayData(strategyParams)));
+        scope.AddSubScope(childScope);
+      }
+      return null;
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.RealVector/SelfAdaptiveNormalAllPositionsManipulator.cs
===================================================================
--- /trunk/sources/HeuristicLab.RealVector/SelfAdaptiveNormalAllPositionsManipulator.cs	(revision 99)
+++ /trunk/sources/HeuristicLab.RealVector/SelfAdaptiveNormalAllPositionsManipulator.cs	(revision 99)
@@ -0,0 +1,55 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Random;
+
+namespace HeuristicLab.RealVector {
+  public class SelfAdaptiveNormalAllPositionsManipulator : RealVectorManipulatorBase {
+    public override string Description {
+      get { return @"Manipulates each dimension in the real vector with the mutation strength given in the strategy parameter vector"; }
+    }
+
+    public SelfAdaptiveNormalAllPositionsManipulator()
+      : base() {
+      AddVariableInfo(new VariableInfo("StrategyVector", "The strategy vector determining the strength of the mutation", typeof(DoubleArrayData), VariableKind.In));
+    }
+
+    public static double[] Apply(double[] strategyParameters, IRandom random, double[] vector) {
+      NormalDistributedRandom N = new NormalDistributedRandom(random, 0.0, 1.0);
+      if (strategyParameters.Length != vector.Length)
+        throw new InvalidOperationException("ERROR: Strategy Vector must be as long as parameter vector");
+      for (int i = 0; i < vector.Length; i++) {
+        vector[i] = vector[i] + (N.NextDouble() * strategyParameters[i]);
+      }
+      return vector;
+    }
+
+    protected override double[] Manipulate(IScope scope, IRandom random, double[] vector) {
+      double[] strategyVector = scope.GetVariableValue<DoubleArrayData>("StrategyVector", true).Data;
+      return Apply(strategyVector, random, vector);
+    }
+  }
+}